VERSION 5.00
Begin VB.Form frmLogin 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Login"
   ClientHeight    =   2985
   ClientLeft      =   2685
   ClientTop       =   5370
   ClientWidth     =   7635
   Icon            =   "frmLogin.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2985
   ScaleWidth      =   7635
   ShowInTaskbar   =   0   'False
   Tag             =   "Login"
   Begin VB.ComboBox ComboLocation 
      Height          =   315
      Left            =   2025
      TabIndex        =   14
      Top             =   2520
      Width           =   3870
   End
   Begin VB.CommandButton cmdSetLocation 
      Caption         =   "Set Location"
      Height          =   360
      Left            =   6120
      TabIndex        =   13
      Top             =   2520
      Width           =   1380
   End
   Begin VB.ComboBox ComboLanguage 
      Height          =   315
      Left            =   2025
      TabIndex        =   11
      Top             =   2022
      Width           =   3870
   End
   Begin VB.ComboBox ComboDatabase 
      Height          =   315
      Left            =   2040
      TabIndex        =   10
      Top             =   1056
      Width           =   3870
   End
   Begin VB.TextBox txtHostName 
      Height          =   285
      Left            =   2025
      TabIndex        =   9
      Top             =   1590
      Width           =   3870
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   360
      Left            =   6360
      TabIndex        =   5
      Tag             =   "Cancel"
      Top             =   600
      Width           =   1140
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   360
      Left            =   6360
      TabIndex        =   4
      Tag             =   "OK"
      Top             =   120
      Width           =   1140
   End
   Begin VB.TextBox txtPassword 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   2025
      PasswordChar    =   "*"
      TabIndex        =   1
      Top             =   588
      Width           =   3870
   End
   Begin VB.TextBox txtUserName 
      Height          =   285
      Left            =   2025
      TabIndex        =   3
      Top             =   120
      Width           =   3870
   End
   Begin VB.Label Label4 
      Caption         =   "Web Service"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   2520
      Width           =   1680
   End
   Begin VB.Label Label3 
      Caption         =   "Language"
      Height          =   255
      Left            =   105
      TabIndex        =   8
      Top             =   2040
      Width           =   1680
   End
   Begin VB.Label Label2 
      Caption         =   "Host Name"
      Height          =   255
      Left            =   105
      TabIndex        =   7
      Top             =   1560
      Width           =   1680
   End
   Begin VB.Label Label1 
      Caption         =   "Database"
      Height          =   255
      Left            =   105
      TabIndex        =   6
      Top             =   1080
      Width           =   1680
   End
   Begin VB.Label lblLabels 
      Caption         =   "&Password:"
      Height          =   255
      Index           =   1
      Left            =   105
      TabIndex        =   0
      Tag             =   "&Password:"
      Top             =   600
      Width           =   1680
   End
   Begin VB.Label lblLabels 
      Caption         =   "&User Name:"
      Height          =   255
      Index           =   0
      Left            =   105
      TabIndex        =   2
      Tag             =   "&User Name:"
      Top             =   120
      Width           =   1680
   End
End
Attribute VB_Name = "frmLogin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public m_nStatus As Integer

Private Sub Form_Load()
    Initialize False
End Sub

Private Sub Initialize(ByVal bSetLocation As Boolean)

On Error GoTo handleErr

    If bSetLocation Then
        AddLocation
        g_strWebServiceLocation = ComboLocation.Text
    Else
        g_strWebServiceLocation = GetSetting(App.Title, "Settings", "WebServiceLocation", "http://localhost:9080/IRMWebServices")
        InitLocationList
        SetValues
    End If

    
    Screen.MousePointer = vbHourglass
    
    'Initialize the LoginManager Service
    InitLoginManager
    
    'If we got here Enable Login controls since we can connect to Web Services
    txtHostName.Enabled = True
    txtUserName.Enabled = True
    txtPassword.Enabled = True
    ComboDatabase.Enabled = True
    ComboLanguage.Enabled = True
    cmdOK.Enabled = True
    
    'Get the List of Databases that are available
    Dim strDataSourceListXML As String
    
    'strDataSourceListXML = getDataSourceList
    strDataSourceListXML = getDataSourceList2
    
    Dim objDomDocument As MSXML2.DOMDocument
    g_strTrace = "CreateObject(""MSXML2.DOMDocument"")"
    Set objDomDocument = CreateObject("MSXML2.DOMDocument")
    
    ComboDatabase.Clear
    
    'Populate the combo box with database jndi names
    If objDomDocument.LoadXml(strDataSourceListXML) Then
        
        Dim objList As IXMLDOMElement
        Set objList = objDomDocument.selectSingleNode("List")
        Dim objItem As IXMLDOMElement
        
        For Each objItem In objList.getElementsByTagName("Item")
            ComboDatabase.AddItem objItem.getAttribute("JNDIName")
        Next objItem
    
        ComboDatabase.ListIndex = 0
        
    Else
        
        MsgBox objDomDocument.parseError.reason & " " & objDomDocument.parseError.srcText
    
    End If
    
    Screen.MousePointer = vbDefault

    Beep
    
Exit Sub

handleErr:
    
    Screen.MousePointer = vbDefault
    
    Dim bErrorHandelled As Boolean
    
    If -2147024809 = Err.Number Then
        
        bErrorHandelled = HandleError("Could not load the WSDL file <LoginManagerEJBService.wsdl> at the location: " & g_strWebServiceLocation & WSDL_FILE_PATH & _
        ". Check that the Web Services Location is correct or that the Service has started!")
        'This errror indicates that the location for the web services is invalid
        If Not bErrorHandelled Then
            DisableControls
            m_nStatus = LOGIN_BAD_WEB_SERVICE_LOCATION
        End If
        
    ElseIf 5415 = Err.Number Then
        bErrorHandelled = HandleError("Check that the 'soap:address location' value is correct in all ...Service.WSDL files in the location " & g_strWebServiceLocation & WSDL_FILE_PATH & " on the server you are connecting to.")
        If Not bErrorHandelled Then
            DisableControls
            m_nStatus = LOGIN_BAD_WEB_SERVICE_LOCATION
        End If
    Else
        bErrorHandelled = HandleError(g_strTrace)
    End If
    
    If bErrorHandelled Then Resume
    
End Sub

Private Sub DisableControls()
    txtHostName.Enabled = False
    txtUserName.Enabled = False
    txtPassword.Enabled = False
    ComboDatabase.Enabled = False
    ComboLanguage.Enabled = False
    cmdOK.Enabled = False
End Sub

Private Sub cmdSetLocation_Click()
    Initialize True
End Sub

Private Sub cmdCancel_Click()
    m_nStatus = LOGIN_CANCEL
    Me.Hide
End Sub

Private Sub cmdOK_Click()
    
On Error GoTo errHandler

    Screen.MousePointer = vbHourglass
    
    'Save login values
    g_strUserName = txtUserName.Text
    g_strPassword = txtPassword.Text
    g_strDatabase = ComboDatabase.Text
    g_strHostName = txtHostName.Text
    g_strLanguage = ComboLanguage.Text

    Login

    Screen.MousePointer = vbDefault
    
    SaveSettings

    m_nStatus = LOGIN_OK
    Me.Hide

Exit Sub

errHandler:

    Screen.MousePointer = vbDefault
    
    If HandleError Then Resume

End Sub

Private Sub SaveSettings()
    'Save these settings in the Windows Registry for next login (we're lazy)
    SaveSetting App.Title, "Settings", "HostName", txtHostName.Text
    SaveSetting App.Title, "Settings", "UserName", txtUserName.Text
    SaveSetting App.Title, "Settings", "Password", txtPassword.Text
    SaveSetting App.Title, "Settings", "Language", ComboLanguage.Text
    SaveSetting App.Title, "Settings", "WebServiceLocation", g_strWebServiceLocation
    
    Dim strItem As String
    Dim objDom As DOMDocument
    Dim objList
    Dim objItem
    Set objDom = New DOMDocument
    Set objList = objDom.createElement("l")
    objDom.appendChild (objList)
    
    Dim i As Integer
    For i = 0 To ComboLocation.ListCount
        Set objItem = objDom.createElement("i")
        strItem = ComboLocation.List(i)
        If Len(strItem) Then
            objItem.Text = strItem
            objList.appendChild (objItem)
        End If
    Next i
    SaveSetting App.Title, "Settings", "LocationList", objDom.xml
    
End Sub

Private Sub AddLocation()
    Dim bFound As Boolean
    Dim strTemp As String
    strTemp = ComboLocation.Text
    Dim i As Integer
    bFound = False
    For i = 0 To ComboLocation.ListCount
        If ComboLocation.List(i) = strTemp Then
            bFound = True
            Exit For
        End If
    Next i
    If Not bFound Then
        ComboLocation.AddItem strTemp
    End If
End Sub

Private Sub InitLocationList()
    Dim strLocationXml As String
    strLocationXml = "<l><i>http://localhost:9080/IRMWebServices</i></l>"
    strLocationXml = GetSetting(App.Title, "Settings", "LocationList", strLocationXml)
    Dim objDom As DOMDocument
    Dim objItem As IXMLDOMElement
    Set objDom = New DOMDocument
    Dim strItem As String
    If objDom.LoadXml(strLocationXml) Then
        For Each objItem In objDom.selectNodes("l/i")
            strItem = objItem.Text
            If Len(strItem) Then
                ComboLocation.AddItem strItem
            End If
        Next
    End If
    
    Dim i As Integer
    For i = 0 To ComboLocation.ListCount
        strItem = ComboLocation.List(i)
        If strItem = g_strWebServiceLocation Then
            ComboLocation.ListIndex = i
            Exit For
        End If
    Next i

End Sub

'Initialize Login fields
Private Sub SetValues()

    Dim i As Integer
    Dim strLanguage As String
    
    AddLocation
    
    txtHostName.Text = GetSetting(App.Title, "Settings", "HostName", "")
    txtUserName.Text = GetSetting(App.Title, "Settings", "UserName", "Administrator")
    txtPassword.Text = GetSetting(App.Title, "Settings", "Password", "cronos")

    strLanguage = GetSetting(App.Title, "Settings", "Language", "en")
    
    ComboLanguage.AddItem "en"
    ComboLanguage.AddItem "fr"
    ComboLanguage.AddItem "de"
    ComboLanguage.AddItem "it"
    ComboLanguage.AddItem "zh"
    ComboLanguage.AddItem "ja"
    ComboLanguage.AddItem "ko"
    ComboLanguage.AddItem "pt"
    ComboLanguage.AddItem "es"
            
    For i = 0 To ComboLanguage.ListCount
        If ComboLanguage.List(i) = strLanguage Then
            ComboLanguage.ListIndex = i
            Exit For
        End If
    Next i
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    m_nStatus = LOGIN_CANCEL
End Sub

Public Function getDataSourceList2() As String
On Error GoTo errHandler
    
    Dim objReader As SoapReader30
    Dim objResultElm As IXMLDOMElement
    Dim objFaultElm As IXMLDOMElement
    
    Dim objConnector  As ISoapConnector
    Set objConnector = New HttpConnector30
    
    objConnector.Property("EndPointURL") = g_strWebServiceLocation & "/servlet/rpcrouter"
    objConnector.Connect
    
    objConnector.Property("SoapAction") = ""
    objConnector.BeginMessage
    
    Dim objSerializer As SoapSerializer30
    Set objSerializer = New SoapSerializer30
    objSerializer.Init objConnector.InputStream
    
    With objSerializer
        .StartEnvelope
        .SoapNamespace "xsi", XSI
        .SoapNamespace "SOAP-ENC", ENCODING_STYLE
        .SoapNamespace "xsd", XSD
            .StartBody
                .StartElement "getDataSourceList", LOGIN_MANAGER_EJB
                .EndElement
            .EndBody
        .EndEnvelope
    End With
    
    objConnector.EndMessage
        
    Set objReader = New SoapReader30
    objReader.Load objConnector.OutputStream
    
    If Not objReader.Fault Is Nothing Then
        Err.Raise SOAP_ERROR, , objReader.FaultString.Text
    Else
        getDataSourceList2 = objReader.RpcResult.Text
    End If
    Set objReader = Nothing
    Set objConnector = Nothing
    Set objSerializer = Nothing
Exit Function
errHandler:
    If HandleError Then Resume
End Function

