<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:template match="/">
		<fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">

			<!-- defines page layout -->
			<fo:layout-master-set>
				<fo:simple-page-master master-name="simple" page-width="21cm" page-height="27.9cm" margin-top="0.5cm" margin-bottom="0.5cm" margin-left="0.5cm" margin-right="0.5cm">
					<fo:region-body />
				</fo:simple-page-master>
			</fo:layout-master-set>


			<!-- defines the content -->
			<fo:page-sequence master-reference="simple">

				<fo:flow flow-name="xsl-region-body">
					<fo:block font-size="16pt" font-family="Helvetica" font-weight="bold" line-height="26pt" space-after.optimum="12pt" text-align="center">Folder Report</fo:block>
				
					<fo:table border-top="solid black" border-bottom="solid black" border-left="solid black" border-right="solid black" font-size="6.5pt">
						<!-- Column width setting  -->
						<fo:table-column column-width="7cm" />
						<fo:table-column column-width="3.5cm" />
						<fo:table-column column-width="5.2cm" />
						<fo:table-column column-width="1.5cm" />
						<fo:table-column column-width="1.5cm" />						
						
						<fo:table-header>
							<!-- Report Headers   -->
							<fo:table-row>
								<!-- File Plan Location -->
								<fo:table-cell border-top="solid black" border-bottom="solid black" border-right="solid black" padding="3pt">
									<fo:block>
									<xsl:value-of select="//MetaData/List/Item[@FlPlnCmpntAttrDefColNm='FullPath']/@FlPlnCmpntAttrDefCapt"/>
									</fo:block>
								</fo:table-cell>

								<!-- Folder Name -->
								<fo:table-cell border-top="solid black" border-bottom="solid black" border-right="solid black" padding="3pt">
									<fo:block >
									<xsl:value-of select="//MetaData/List/Item[@FlPlnCmpntAttrDefColNm='TS_FlPlnCmpnt.FlPlnCmpntNm']/@FlPlnCmpntAttrDefCapt"/>
									</fo:block>
								</fo:table-cell>
								
								<!-- Folder Title -->
								<fo:table-cell border-top="solid black" border-bottom="solid black" border-right="solid black" padding="3pt">
									<fo:block >
									<xsl:value-of select="//MetaData/List/Item[@FlPlnCmpntAttrDefColNm='TS_FlPlnCmpnt.FlPlnCmpntTtl']/@FlPlnCmpntAttrDefCapt"/>
									</fo:block>
								</fo:table-cell>
								
								<!-- Life Cycle Code Name -->
								<fo:table-cell border-top="solid black" border-bottom="solid black" border-right="solid black" padding="3pt">
									<fo:block >
									<xsl:value-of select="//MetaData/List/Item[@FlPlnCmpntAttrDefColNm='TS_LfCclCd.LfCclCdNm']/@FlPlnCmpntAttrDefCapt"/>
									</fo:block>
								</fo:table-cell>

								<!-- Disposal Authority -->
								<fo:table-cell border-top="solid black" border-bottom="solid black" padding="3pt">
									<fo:block >
									<xsl:value-of select="//MetaData/List/Item[@FlPlnCmpntAttrDefColNm='TS_FlPlnCmpnt.DsplAthrtyID']/@FlPlnCmpntAttrDefCapt"/>
									</fo:block>
								</fo:table-cell>

							</fo:table-row>													
						</fo:table-header>
						<!-- Records -->
						<fo:table-body>
							<xsl:for-each select="//Data/List/Item">

									<fo:table-row>
										<!-- File Plan Location -->
										<fo:table-cell border-right="solid black" padding="2pt">
											<fo:block text-align="start">
												<xsl:value-of select="@FullPath" />		 
											</fo:block>
										</fo:table-cell>

										<!-- Folder Name -->
										<fo:table-cell border-right="solid black"   padding="2pt">
											<fo:block text-align="start">
												<xsl:value-of select="@TS_FlPlnCmpnt.FlPlnCmpntNm" />
											</fo:block>
										</fo:table-cell>
										
										<!-- Folder Title -->
										<fo:table-cell border-right="solid black"   padding="2pt">
											<fo:block text-align="start">
												<xsl:value-of select="@TS_FlPlnCmpnt.FlPlnCmpntTtl" />
											</fo:block>
										</fo:table-cell>
										
										<!-- Life Cycle Code -->
										<fo:table-cell border-right="solid black" padding="2pt">
											<fo:block text-align="start">
												<xsl:value-of select="@TS_LfCclCd.LfCclCdNm" />												
											</fo:block>
										</fo:table-cell>

										<!-- Disposal Authority -->
										<fo:table-cell border-right="solid black" padding="2pt">
											<fo:block text-align="start">
												<xsl:value-of select="@TS_FlPlnCmpnt.DsplAthrtyID" />												
											</fo:block>
										</fo:table-cell>

									</fo:table-row>

							</xsl:for-each>
						</fo:table-body>
					</fo:table>

				</fo:flow>
			</fo:page-sequence>
		</fo:root>
	</xsl:template>

</xsl:stylesheet>